import request from '@/utils/request';

/**
 * 分页查询角色
 * @param params 查询条件
 */
export async function pageRoles(params) {
  const res = await request.get('/sys/role/page', {
    params
  });
  if (res.data.code == 0) {
    // return {
    //   list: res.data.data.records,
    //   count: res.data.data.total
    // }
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

export async function putRoles(params) {
  const res = await request.put('/sys/role/update', params);
  if (res.data.code == 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询角色列表
 * @param params 查询条件
 */
export async function listRoles(params) {
  let par = new URLSearchParams(params);
  const res = await request.get(`/sys/role/page?` + par, {});
  if (res.data.code == 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加角色
 * @param data 角色信息
 */
export async function addRole(data) {
  const res = await request.post('/sys/role/add', data);
  if (res.data.code == 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改角色
 * @param data 角色信息
 */
export async function updateRole(data) {
  const res = await request.put('/system/role', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除角色
 * @param id 角色id
 */
export async function removeRole(id, f) {
  let res;
  if (f) {
    res = await request.delete('/sys/role/delete', {
      data: id
    });
  } else {
    res = await request.delete('/sys/role/delete', {
      data: [id]
    });
  }

  if (res.data.code == 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除角色
 * @param ids 角色id集合
 */
export async function removeRoles(data) {
  const res = await request.delete('/system/role/batch', {
    data
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 获取角色分配的菜单
 * @param roleId 角色id
 */
export async function listRoleMenus(id) {
  const res = await request.get(`/sys/role/getByRoleId/${id}`);
  if (res.data.code == 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改角色菜单
 * @param roleId 角色id
 * @param data 菜单id集合
 */
export async function updateRoleMenus(data) {
  const res = await request.post('/sys/role/ResourceGrant', data);
  if (res.data.code == 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}


/**
 * 点击新增获取角色列表
 * @param params 
 */
export async function getlistRole (id) {
  const res = await request.get('/sys/role/getByRoleName');
  if (res.data.code == 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}